diff --git a/src/os_regex/os_regex_compile.c b/src/os_regex/os_regex_compile.c
index 393c97e55be..0789ef2d7a5 100644
--- a/src/os_regex/os_regex_compile.c
+++ b/src/os_regex/os_regex_compile.c
@@ -76,7 +76,7 @@ int OSRegex_Compile(const char *pattern, OSRegex *reg, int flags)
     pt = new_str;
 
     /* Get the number of sub patterns */
-    do {
+    while (*pt != '\0') {
         if (*pt == BACKSLASH) {
             pt++;
             /* Give the new values for each regex */
@@ -164,7 +164,7 @@ int OSRegex_Compile(const char *pattern, OSRegex *reg, int flags)
             count++;
         }
         pt++;
-    } while (*pt != '\0');
+    }
 
     /* After the whole pattern is read, the parentheses must all be closed */
     if (parenthesis != 0) {
@@ -225,7 +225,7 @@ int OSRegex_Compile(const char *pattern, OSRegex *reg, int flags)
             }
 
             /* If string ends with $, set the END_SET flag */
-            if (*(pt - 1) == ENDREGEX) {
+            if (pt > new_str && *(pt - 1) == ENDREGEX) {
                 *(pt - 1) = '\0';
                 reg->flags[i] |= END_SET;
             }
diff --git a/src/os_regex/os_regex_execute.c b/src/os_regex/os_regex_execute.c
index 6e48801abcc..84660fa1911 100644
--- a/src/os_regex/os_regex_execute.c
+++ b/src/os_regex/os_regex_execute.c
@@ -128,7 +128,7 @@ static const char *_OS_Regex(const char *pattern, const char *str, const char **
     const char *pt_error_str[4] = {NULL, NULL, NULL, NULL};
 
     /* Will loop the whole string, trying to find a match */
-    do {
+    for (st = str; *st != '\0'; ++st) {
         switch (*pt) {
             case '\0':
                 if (!(flags & END_SET) || ((flags & END_SET) && (*st == '\0'))) {
@@ -373,7 +373,7 @@ static const char *_OS_Regex(const char *pattern, const char *str, const char **
         pt = pattern;
         r_code = NULL;
 
-    } while (*(++st) != '\0');
+    }
 
     /* Match for a possible last parenthesis */
     if (prts_closure) {
@@ -421,4 +421,3 @@ static const char *_OS_Regex(const char *pattern, const char *str, const char **
 
     return (NULL);
 }
-
